' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2010                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVIL Sample Program
' mCYtB^ݒ_CAO
'
' 쐬 : N.Moriguchi
'
'  : 2011/02/14 
'
' -----------------------------------------------------------------
Public Class FormNoiseFilterSetting
    Public int_width As Integer
    Public int_scale As Integer
    Public di_width As Integer
    Public di_scale As Integer

    ''' <summary>
    ''' tH[
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' NoiseFilterSettingtH[̏B
    ''' </remarks>
    Private Sub FormNoiseFilterSetting_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim Time As Double
        ComboBoxIntWidth.SelectedIndex = int_width
        ComboBoxIntScale.SelectedIndex = int_scale
        ComboBoxDiWidth.SelectedIndex = di_width
        ComboBoxDiScale.SelectedIndex = di_scale

        Time = WidthTimeConversion(ComboBoxIntWidth.SelectedIndex) * ComboBoxIntScale.SelectedIndex
        TextBoxIntTime.Text = WidthTimeConversion(Time)
        Time = WidthTimeConversion(ComboBoxDiWidth.SelectedIndex) * ComboBoxDiScale.SelectedIndex
        TextBoxDiTime.Text = WidthTimeConversion(Time)
    End Sub

    ''' <summary>
    ''' mCYtB^p[^ݒ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' mCYtB^͕IB
    ''' </remarks>
    Private Sub ComboBoxIntWidth_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxIntWidth.SelectionChangeCommitted
        Dim Time As Double

        Time = WidthTimeConversion(ComboBoxIntWidth.SelectedIndex) * ComboBoxIntScale.SelectedIndex
        TextBoxIntTime.Text = WidthTimeConversion(Time)

    End Sub

    ''' <summary>
    ''' mCYtB^p[^ݒ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' mCYtB^̓XP[IB
    ''' </remarks>
    Private Sub ComboBoxIntScale_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxIntScale.SelectionChangeCommitted
        Dim Time As Double

        Time = WidthTimeConversion(ComboBoxIntWidth.SelectedIndex) * ComboBoxIntScale.SelectedIndex
        TextBoxIntTime.Text = WidthTimeConversion(Time)

    End Sub

    ''' <summary>
    ''' mCYtB^p[^ݒ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' mCYtB^o͕IB
    ''' </remarks>
    Private Sub ComboBoxDiWidth_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxDiWidth.SelectionChangeCommitted
        Dim Time As Double

        Time = WidthTimeConversion(ComboBoxDiWidth.SelectedIndex) * ComboBoxDiScale.SelectedIndex
        TextBoxDiTime.Text = WidthTimeConversion(Time)

    End Sub

    ''' <summary>
    ''' mCYtB^p[^ݒ
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' mCYtB^o̓XP[IB
    ''' </remarks>
    Private Sub ComboBoxDiScale_SelectionChangeCommitted(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxDiScale.SelectionChangeCommitted
        Dim Time As Double

        Time = WidthTimeConversion(ComboBoxDiWidth.SelectedIndex) * ComboBoxDiScale.SelectedIndex
        TextBoxDiTime.Text = WidthTimeConversion(Time)

    End Sub

    ''' <summary>
    ''' OK{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' OK{^B
    ''' </remarks>
    Private Sub ButtonOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonOK.Click
        int_width = ComboBoxIntWidth.SelectedIndex
        int_scale = ComboBoxIntScale.SelectedIndex
        di_width = ComboBoxDiWidth.SelectedIndex
        di_scale = ComboBoxDiScale.SelectedIndex

        Me.DialogResult = Windows.Forms.DialogResult.OK

    End Sub

    ''' <summary>
    ''' Cancel{^
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks>
    ''' Cancel{^B
    ''' </remarks>
    Private Sub ButtonCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonCancel.Click
        Dim Time As Double
        ComboBoxIntWidth.SelectedIndex = int_width
        ComboBoxIntScale.SelectedIndex = int_scale
        ComboBoxDiWidth.SelectedIndex = di_width
        ComboBoxDiScale.SelectedIndex = di_scale

        Time = WidthTimeConversion(ComboBoxIntWidth.SelectedIndex) * ComboBoxIntScale.SelectedIndex
        TextBoxIntTime.Text = WidthTimeConversion(Time)
        Time = WidthTimeConversion(ComboBoxDiWidth.SelectedIndex) * ComboBoxDiScale.SelectedIndex
        TextBoxDiTime.Text = WidthTimeConversion(Time)

        Me.DialogResult = Windows.Forms.DialogResult.Cancel

    End Sub

    ''' <summary>
    ''' Widthԕϊ֐
    ''' </summary>
    ''' <remarks>
    ''' R{{bNX̑IԒlɂĕԂB
    ''' </remarks>
    Private Function WidthTimeConversion(ByVal Value As Integer) As Double
        Dim result As Double = 0
        Select Case Value
            Case 0 : result = 0
            Case 1 : result = 60.6
            Case 2 : result = 121.2
            Case 3 : result = 242.4
            Case 4 : result = 484.8
            Case 5 : result = 969.7
            Case 6 : result = 1830
            Case 7 : result = 3870
            Case 8 : result = 7750
            Case 9 : result = 15150
            Case 10 : result = 31030
            Case 11 : result = 62060
            Case 12 : result = 124100
            Case 13 : result = 248200
            Case 14 : result = 496400
            Case 15 : result = 992900
        End Select
        Return result

    End Function

    ''' <summary>
    ''' Pʕϊ֐
    ''' </summary>
    ''' <remarks>
    ''' ͒lɂnsAusAmsɕϊB
    ''' </remarks>
    Private Function WidthTimeConversion(ByVal Value As Double) As String
        Dim result As String = Nothing

        If (1 > Value / 1000) Then
            result = (Value.ToString + "(ns)")
        ElseIf (1 > Value / 1000000) Then
            result = ((Value / 1000).ToString + "(us)")
        Else
            result = ((Value / 1000000).ToString + "(ms)")
        End If
        Return result

    End Function

End Class